<template>
  <div id="global">
    <div>
      <div class="row">
        <span class="col-1" style="padding-top: 10px"> First Name : </span>
        <b-form-input
          class="col-10"
          v-model="first_name"
          :placeholder="items.firstName"
          style="margin-bottom: 20px"
        ></b-form-input>
      </div>
      <div class="row">
        <span class="col-1" style="padding-top: 10px"> Last Name : </span>
        <b-form-input
          class="col-10"
          v-model="last_name"
          :placeholder="items.lastName"
        ></b-form-input>
      </div>
    </div>
    <div style="margin-top: 30px">
      <b-form-group label="Select your prefered currency">
        <b-form-radio-group
          id="radio-group-2"
          v-model="selected"
          name="radio-sub-component"
        >
          <b-form-radio value="EUR">EUR €</b-form-radio>
          <b-form-radio value="USD">USD $</b-form-radio>
        </b-form-radio-group>
      </b-form-group>
    </div>
    <b-button variant="success" @click="modify()"> Modify </b-button>
  </div>
</template>

<script>
import Vue from 'vue'
import { mapGetters } from 'vuex'
import { Notyf } from 'notyf'
import 'notyf/notyf.min.css'

export default {
  components: {},
  data() {
    return {
      first_name: '',
      last_name: '',
      selected: '',
      items: [{}],
      current: {},
    }
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  methods: {
    async dataProvider(ctx) {
      return await Vue.prototype.$http
        .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
        .then((result) => result.data)
        .then((data) => {
          this.items = data
          this.selected = this.items.currency
          // console.log('data', data)
        })
        .catch((_error) => {
          return []
        })
    },
    async modify(ctx) {
      const user = {}
      if (this.first_name) {
        user.firstName = this.first_name
      }
      if (this.last_name) {
        user.lastName = this.last_name
      }
      if (this.selected) {
        user.currency = this.selected
      }
      // console.log("user", user)
      return await Vue.prototype.$http
        .patch(`http://localhost:3000/api/users/${this.currentUser.id}`, user)
        .then((res) => {
          this.dataProvider()
          this.first_name = ''
          this.last_name = ''
          const notyf = new Notyf()
          // eslint-disable-next-line no-mixed-spaces-and-tabs
          notyf.success('Profile updated !')
        })
      // .catch(err => {console.log(err)})
    },
  },
  mounted() {
    this.dataProvider()
  },
}
</script>

<style scoped>
#global {
  width: 100%;
  text-align: center;
}
</style>